---
title: '<details>: The Details disclosure element'
slug: Web/HTML/Element/details
tags:
  - Disclosure Box
  - Disclosure Widget
  - Element
  - HTML
  - HTML interactive elements
  - Reference
  - Web
  - details
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML Details Element (<code>&lt;details&gt;</code>)</strong> creates a disclosure widget in which information is visible only when the widget is toggled into an "open" state.</span> A summary or label can be provided using the {{HTMLElement("summary")}} element.</p>

<p>A disclosure widget is typically presented onscreen using a small triangle which rotates (or twists) to indicate open/closed status, with a label next to the triangle. If the first child of the <code>&lt;details&gt;</code> element is a <code>&lt;summary&gt;</code>, the contents of the <code>&lt;summary&gt;</code> element are used as the label for the disclosure widget.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/details.html", "tabbed-shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div class="note">
<p><strong>Note:</strong> The common use of a triangle which rotates or twists around to represent opening or closing the widget is why these are sometimes called "twisties."</p>
</div>

<p>A <code>&lt;details&gt;</code> widget can be in one of two states. The default <em>closed</em> state displays only the triangle and the label inside <code>&lt;summary&gt;</code> (or a {{Glossary("user agent")}}-defined default string if no <code>&lt;summary&gt;</code>). This might look like the following:</p>

<figure style="margin: 1em 0; padding: 1em; border: 1px solid black; box-shadow: 0 0 4px 1px black; width: 640px;"><img alt="Screenshot of closed &lt;details&gt; widget. A black left-pointing triangle sits to the right of the text “System Requirements”." src="details-closed.png" style="height: 26px; width: 191px;"></figure>

<p>Here we see a standard disclosure widget with the label "System Requirements", in its default closed state. When the user clicks on the widget or focuses it then presses the space bar, it "twists" open, revealing its contents:</p>

<figure style="margin: 1em 0; padding: 1em; border: 1px solid black; box-shadow: 0 0 4px 1px black; width: 640px;"><img alt="Screenshot of open &lt;details&gt; widget. The triangle now points downward, and a detailed description of what “System Requirements” means is shown." src="details-open.png" style="height: 96px; width: 640px;"></figure>

<p>From there, you can use CSS to style the disclosure widget, and you can programmatically open and close the widget by setting/removing its {{htmlattrxref("open", "details")}} attribute.</p>

<p>By default when closed, the widget is only tall enough to display the disclosure triangle and summary. When open, it expands to display the details contained within.</p>

<div class="note">
<p><strong>Note:</strong> Unfortunately, at this time there's no built-in way to animate the transition between open and closed.</p>
</div>

<p>Fully standards-compliant implementations automatically apply the CSS <code>{{cssxref("display")}}: list-item</code> to the {{HTMLElement("summary")}} element. You can use this to customize its appearance further. See {{anch("Customizing the disclosure widget")}} for further details.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, sectioning root, interactive content, palpable content.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>One {{HTMLElement("summary")}} element followed by <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">flow content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">flow content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td>{{ARIARole("group")}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>No <code>role</code> permitted</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLDetailsElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<dl>
 <dt>{{htmlattrdef("open")}}</dt>
 <dd>This Boolean attribute indicates whether or not the details — that is, the contents of the <code>&lt;details&gt;</code> element — are currently visible. The default, <code>false</code>, means the details are not visible.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>In addition to the usual events supported by HTML elements, the <code>&lt;details&gt;</code> element supports the {{event("toggle")}} event, which is dispatched to the <code>&lt;details&gt;</code> element whenever its state changes between open and closed. It is sent <em>after</em> the state is changed, although if the state changes multiple times before the browser can dispatch the event, the events are coalesced so that only one is sent.</p>

<p>You can use an event listener for the <code>toggle</code> event to detect when the widget changes state:</p>

<pre class="brush: js">details.addEventListener("toggle", event =&gt; {
  if (details.open) {
    /* the element was toggled open */
  } else {
    /* the element was toggled closed */
  }
});</pre>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_disclosure_example">A simple disclosure example</h3>

<p>This example shows a <code>&lt;details&gt;</code> element with no provided summary.</p>

<pre class="brush: html">&lt;details&gt;
  &lt;p&gt;Requires a computer running an operating system. The computer
  must have some memory and ideally some kind of long-term storage.
  An input device as well as some form of output device is
  recommended.&lt;/p&gt;
&lt;/details&gt;</pre>

<p>In this situation, the browser will use a default summary string (usually "Details"). Here's what your browser does with it:</p>

<p>{{EmbedLiveSample("A_simple_disclosure_example", 650, 150)}}</p>

<h3 id="Providing_a_summary">Providing a summary</h3>

<p>This example adds a summary to the above example by using the {{HTMLElement("summary")}} element inside <code>&lt;details&gt;</code>, like this:</p>

<pre class="brush: html">&lt;details&gt;
  &lt;summary&gt;System Requirements&lt;/summary&gt;
  &lt;p&gt;Requires a computer running an operating system. The computer
  must have some memory and ideally some kind of long-term storage.
  An input device as well as some form of output device is
  recommended.&lt;/p&gt;
&lt;/details&gt;</pre>

<p>The result from this HTML is this:</p>

<p>{{EmbedLiveSample("Providing_a_summary", 650, 150)}}</p>

<h3 id="Creating_an_open_disclosure_box">Creating an open disclosure box</h3>

<p>To start the <code>&lt;details&gt;</code> box in its open state, add the Boolean <code>open</code> attribute:</p>

<pre class="brush: html">&lt;details open&gt;
  &lt;summary&gt;System Requirements&lt;/summary&gt;
  &lt;p&gt;Requires a computer running an operating system. The computer
  must have some memory and ideally some kind of long-term storage.
  An input device as well as some form of output device is
  recommended.&lt;/p&gt;
&lt;/details&gt;</pre>

<p>This results in:</p>

<p>{{EmbedLiveSample("Creating_an_open_disclosure_box", 650, 150)}}</p>

<h3 id="Customizing_the_appearance">Customizing the appearance</h3>

<p>Now let's apply some CSS to customize the appearance of the disclosure box.</p>

<h4 id="CSS">CSS</h4>

<pre class="brush: css">details {
  font: 16px "Open Sans", Calibri, sans-serif;
  width: 620px;
}

details &gt; summary {
  padding: 2px 6px;
  width: 15em;
  background-color: #ddd;
  border: none;
  box-shadow: 3px 3px 4px black;
  cursor: pointer;
}

details &gt; p {
  border-radius: 0 0 10px 10px;
  background-color: #ddd;
  padding: 2px 6px;
  margin: 0;
  box-shadow: 3px 3px 4px black;
}
</pre>

<p>This CSS creates a look similar to a tabbed interface, where clicking the tab opens it to reveal its contents.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;details&gt;
  &lt;summary&gt;System Requirements&lt;/summary&gt;
  &lt;p&gt;Requires a computer running an operating system. The computer
  must have some memory and ideally some kind of long-term storage.
  An input device as well as some form of output device is
  recommended.&lt;/p&gt;
&lt;/details&gt;</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Customizing_the_appearance", 650, 150)}}</p>

<h3 id="Customizing_the_disclosure_widget">Customizing the disclosure widget</h3>

<p>The disclosure triangle itself can be customized, although this is not as broadly supported. There are variations in how browsers support this customization due to experimental implementations as the element was standardized, so we'll have to use multiple approaches for a while.</p>

<p>The {{HTMLElement("summary")}} element supports the {{cssxref("list-style")}} shorthand property and its longhand properties, such as {{cssxref("list-style-type")}}, to change the disclosure triangle to whatever you choose (usually with {{cssxref("list-style-image")}}). For example, we can remove the disclosure widget icon by setting <code>list-style: none</code>.</p>

<p>Chrome doesn't support this yet, however, so we also need to use its non-standard <code>::-webkit-details-marker</code> <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-element</a> to customize the appearance in that browser.</p>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css; highlight:[12, 15-17]">details {
  font: 16px "Open Sans", Calibri, sans-serif;
  width: 620px;
}

details &gt; summary {
  padding: 2px 6px;
  width: 15em;
  background-color: #ddd;
  border: none;
  box-shadow: 3px 3px 4px black;
  cursor: pointer;
  list-style: none;
}

details &gt; summary::-webkit-details-marker {
  display: none;
}

details &gt; p {
  border-radius: 0 0 10px 10px;
  background-color: #ddd;
  padding: 2px 6px;
  margin: 0;
  box-shadow: 3px 3px 4px black;
}
</pre>

<p>This CSS creates a look similar to a tabbed interface, where activating the tab expands and opens it to reveal its contents.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;details&gt;
  &lt;summary&gt;System Requirements&lt;/summary&gt;
  &lt;p&gt;Requires a computer running an operating system. The computer
  must have some memory and ideally some kind of long-term storage.
  An input device as well as some form of output device is
  recommended.&lt;/p&gt;
&lt;/details&gt;</pre>

<h4 id="Result_2">Result</h4>

<p>{{EmbedLiveSample("Customizing_the_disclosure_widget", 650, 150)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'interactive-elements.html#the-details-element', '&lt;details&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'interactive-elements.html#the-details-element', '&lt;details&gt;')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.details")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTMLElement("summary")}}</li>
</ul>
